#include	"honkon.h"

#define	TRUE	1
#define	FALSE	0


static int
edge( p )
PAIR	*p;
{
	if( p->x1 && p->x1 != 16 && p->y1 && p->y1 != 7 )	return FALSE;
	return ( p->x2 == 0 || p->x2 == 16 || p->y2 == 0 || p->y2 == 7 );
}

static int
betweenH( y, sx, ex )
int	sx;
int	ex;
int	y;

{
	int	j;

	if( sx > ex ){
		j= sx;
		sx= ex;
	}else {
		j= ex;
	}
	for( ; sx <= j; sx++ ){
		if( map[y][sx] >= 0 )	return FALSE;
	}
	return TRUE;
}

static int
betweenV( x, sy, ey )
int	x;
int	sy;
int	ey;
{
	int	i;

	if( sy > ey ){
		i= sy;
		sy= ey;
	}else {
		i= ey;
	}

	for( ; sy <= i; sy++ ){
		if( map[sy][x] >= 0 )	return FALSE;
	}
	return TRUE;
}

static int
lineV( sx, sy, ex, ey )
int	sx;
int	sy;
int	ex;
int	ey;
{
	int	i, j, k, l;

	if( sy > ey ){
		i= ey;
		ey= sy;
		sy= i;
		i= ex;
		ex= sx;
		sx= i;
	}

	for( i= sx - 1; i >= 0; i-- ){
		if( map[sy][i] >= 0 )	break;
	}
	i++;

	for( j= sx + 1; j < 17; j++ ){
		if( map[sy][j] >= 0 )	break;
	}
	j--;

	for( k= ex - 1; k >= 0; k-- ){
		if( map[ey][k] >= 0 )	break;
	}
	k++;

	for( l= ex + 1; l < 17; l++ ){
		if( map[ey][l] >= 0 )	break;
	}
	l--;

	if( l < i || j < k )	return FALSE;
	if( i < k )	i= k;
	if( j > l )	j= l;

	for( k= i; k <= j; k++ ){
		if( betweenV( k, sy, ey ) )	return TRUE;
	}
	return FALSE;
}

static int
lineH( sx, sy, ex, ey )
int	sx;
int	sy;
int	ex;
int	ey;
{
	int	i, j, k, l;

	if( sx > ex ){
		i= ex;
		ex= sx;
		sx= i;
		i= ey;
		ey= sy;
		sy= i;
	}

	for( i= sy - 1; i >= 0; i-- ){
		if( map[i][sx] >= 0 )	break;
	}
	i++;

	for( j= sy + 1; j < 8; j++ ){
		if( map[j][sx] >= 0 )	break;
	}
	j--;

	for( k= ey - 1; k >= 0; k-- ){
		if( map[k][ex] >= 0 )	break;
	}
	k++;

	for( l= ey + 1; l < 8; l++ ){
		if( map[l][ex] >= 0 )	break;
	}
	l--;

	if( l < i || j < k )	return FALSE;
	if( i < k )	i= k;
	if( j > l )	j= l;

	for( k= i; k <= j; k++ ){
		if( betweenH( k, sx, ex ) )	return TRUE;
	}
	return FALSE;
}

int
check( p )
PAIR	*p;
{
	/* אڃ`FbN */
	if( p->x2 == p->x1 ){
		if( p->y2 == p->y1 + 1 || p->y2 == p->y1 - 1 )	return TRUE;
	}else if( p->y2 == p->y1 ){
		if( p->x2 == p->x1 + 1 || p->x2 == p->x1 - 1 )	return TRUE;
	}

	/* 2Ƃ[? */
	if( edge( p ) )	return TRUE;

	/* Ōׂ邩? */
	if( p->x1 > 0 && map[p->y1][p->x1 - 1] < 0 &&
		lineH( p->x2, p->y2, p->x1 - 1, p->y1 ) )	return TRUE;
	if( lineH( p->x2, p->y2, p->x1, p->y1 ) )	return TRUE;
	if( p->x1 < 16 && map[p->y1][p->x1 + 1] < 0 &&
		lineH( p->x2, p->y2, p->x1 + 1, p->y1 ) )	return TRUE;
	if( p->x2 > 0 && map[p->y2][p->x2 - 1] < 0 &&
		lineH( p->x2 - 1, p->y2, p->x1, p->y1 ) )	return TRUE;
	if( p->x2 < 16  && map[p->y2][p->x2 + 1] < 0 &&
		lineH( p->x2 + 1, p->y2, p->x1, p->y1 ) )	return TRUE;

	if( p->y1 > 0 && map[p->y1 - 1][p->x1] < 0 &&
		lineV( p->x2, p->y2, p->x1, p->y1 - 1 ) )	return TRUE;
	if( lineV( p->x2, p->y2, p->x1, p->y1 ) )	return TRUE;
	if( p->y1 < 7 && map[p->y1 + 1][p->x1] < 0 &&
		lineV( p->x2, p->y2, p->x1, p->y1 + 1 ) )	return TRUE;
	if( p->y2 > 0 && map[p->y2 - 1][p->x2] < 0 &&
		lineV( p->x2, p->y2 - 1, p->x1, p->y1 ) )	return TRUE;
	if( p->y2 < 7 && map[p->y2 + 1][p->x2] < 0 &&
		lineV( p->x2, p->y2 + 1, p->x1, p->y1 ) )	return TRUE;

	return FALSE;
}
