/* dialog window for honkon.win */

#include	"honkon.h"
#include	<winop.h>
#include	<string.h>
#include	<HS_wlib.h>
#include	<iocslib.h>


#define	OKX1	52
#define	OKY1	114
#define	OKX2	91
#define	OKY2	129

#define	DIALOG_X	132			/* _CAOJʒu */
#define	DIALOG_Y	76
#define	DIALOG_H	144
#define	DIALOG_V	136


typedef	struct {
	int	pos;
	char	mes[18];
} DIALOGINF;

static	InputClass	input;
static char	*cmenu[]= { "paste" };
static char	*posname[]= { "top", "2nd", "3rd", "4th", "5th" };

static int	clipmenu( WindowID, EventInfo* );
static int	DialogExec( WindowID, EventInfo* );
static int	RankingExec( WindowID, EventInfo* );


static int
clipmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	int	num, px, py;

	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y;
	num= PopUpMenu( px-1, py, cmenu, sizeof cmenu/sizeof(char*), FONT_V );
	if( !num ){
		return UserSendPaste( wp, info );
	}else {
		return FALSE;
	}
}

static int
DialogExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[6], *dp= dbuf;

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, ColorGray );
		DrawSetLine( dp++, OKX1, OKY1, OKX2, OKY2, ShadowUp, OptionShadow );
		DrawSetSymbol( dp++, OKX1 + 14, OKY1 + 2, "Ok", AttrDefault, FONT_V );
		DrawSetSymbol( dp++, 54, 36, "sorry,",
						AttrDefault, FONT_V );
		DrawSetSymbol( dp++, 27, 48, "you cannot take",
						AttrDefault, FONT_V );
		DrawSetSymbol( dp++, 48, 60, "any more",
						AttrDefault, FONT_V );
		WindowDraw( wp, dbuf, dp - dbuf );
		return	TRUE;
	}
	return	FALSE;
}

static int
RankingExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[30], *dp= dbuf;
	DIALOGINF	*dinf;
	int	i;

	dinf= WindowGetClientPointer( wp );
	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, ColorGray );
		DrawSetSymbol( dp++,  24, 12, dinf->mes, AttrDefault, FONT_V );
		DrawSetSymbol( dp++, OKX1 + 14, OKY1 + 2, "Ok", AttrDefault, FONT_V );
		DrawSetLine( dp++, OKX1, OKY1, OKX2, OKY2, ShadowUp, OptionShadow );
		for( i= 0; i < 5; i++ ){
			DrawSetSymbol( dp++, 12, i * 12 + 36, ranking[i].times,
							AttrDefault, FONT_V );
			DrawSetSymbol( dp++, 72, i * 12 + 36, ranking[i].name,
							AttrDefault, FONT_V );
		}
		if( dinf->pos ){
			DrawSetLine( dp++, 71, dinf->pos * 12 + 23,
							132, dinf->pos * 12 + 36, ColorWhite, OptionFill );
			dp+= InputSetDraw( dp, &input );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return	TRUE;
	case EventKey:
		WindowDraw( wp, dbuf, InputKey( dbuf, &input, info->KeyCode, info->ShiftStat ) );
		return TRUE;
	case EventMouseEnter:
	case EventMouseOut:
		WindowDraw( wp, dbuf, InputSetCursorVisible( dbuf, &input, info->option == EventMouseEnter ) );
		return TRUE;
	case EventUser:
		if( dinf->pos ){
			switch( info->ComData ){
			case UserPaste:
			case UserString:
			case UserStrings:
				return	ClipGetKeyboardAll( wp, info );
			}
		}
		return FALSE;
	}
	return	FALSE;
}


int
rank_open( base, end )
WindowID	base;
int	end;
{
	DIALOGINF	dinf;
	EventInfo	myinfo;
	WindowID	cwp, nwp;
	int	x, y;
	int	ret;

	WindowGetScreenPosition( base, &x, &y );
	if( end >= 0 ){
		cwp= WindowSimpleOpen( x + DIALOG_X, y + DIALOG_Y,
							DIALOG_H, DIALOG_V, NULL, RankingExec );
		if( !end || ranking[4].time < end ){
			strcpy( dinf.mes, "Hi-Score ranking" );
			dinf.pos= 0;
		}else {
			int	i;
			for( i= 3; i >= 0; i-- ){
				if( ranking[i].time > end ){
					ranking[i + 1]= ranking[i];
				}else {
					break;
				}
			}
			ranking[++i].time= end;
			strcpy( ranking[i].times, timestr );
			ranking[i].name[0]= NULL;
			strcpy( dinf.mes, "You got " );
			strcat( dinf.mes, posname[i] );
			strcat( dinf.mes, " rank" );
			dinf.pos= i + 1;
			InputSet( &input, 72, dinf.pos * 12 + 24, ranking[i].name,
						10, ColorWhite|AttrReverse, FONT_V );
		}
		WindowSetClientData( cwp, 0, &dinf );
	}else {
		cwp= WindowSimpleOpen( x + DIALOG_X, y + DIALOG_Y,
							DIALOG_H, DIALOG_V, NULL, DialogExec );
		dinf.pos= 0;
	}
	WindowRedraw( cwp );

	MS_CURON();
	for(;;){
		if( !WindowGetEventInfo( &myinfo ) )	continue;
		nwp= WindowGetChild( WindowRootID, &myinfo );
		if( myinfo.option == EventKey && ( nwp == cwp || nwp == base ) ){
			if( myinfo.KeyCode == '\r' ){
				ret= TRUE;
				break;	/* RET */
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp == cwp ){
			if( myinfo.option == EventClose ){
				ret= FALSE;
				break;
			}
			if( myinfo.LeftON && myinfo.y >= OKY1
					&& myinfo.y <= OKY2 ){
				if( myinfo.x >= OKX1 && myinfo.x <= OKX2 ){
					ret= TRUE;
					break;	/* OK */
				}
			}else if( myinfo.RightON && dinf.pos ){
				clipmenu( cwp, &myinfo );
			}else {
				WindowSendEvent( cwp, &myinfo );
			}
		}else if( nwp != base ){
			WindowSendEvent( nwp, &myinfo );
		}
	}

	WindowClose( cwp );
	return ret;
}
